<?php

namespace Drupal\config_reference_content\Plugin\ConfigContentGenerator;

use Drupal\config_reference_content\Plugin\ConfigContentGeneratorBase;
use Drupal\Core\Config\Entity\ConfigEntityBase;
use Drupal\layout_builder\Entity\LayoutBuilderEntityViewDisplay;
use Drupal\block_content\Entity\BlockContent;


/**
 * @ConfigContentGenerator(
 *  id = "inline_block",
 *  label = @Translation("Inline block"),
 * )
 */
class InlineBlock extends ConfigContentGeneratorBase {

  /**
   * {@inheritdoc}
   */
  public function isApplicable(ConfigEntityBase $entity) {
    return $entity instanceof LayoutBuilderEntityViewDisplay;
  }

  /**
   * {@inheritdoc}
   */
  public function getContents(ConfigEntityBase $entity) {
    $contents = [];
    $sections = $entity->getThirdPartySetting('layout_builder', 'sections');
    /** @var \Drupal\layout_builder\Section $section */
    foreach ($sections as $section) {
      /** @var \Drupal\layout_builder\SectionComponent $component */
      foreach ($section->getComponents() as $component) {
        $config = $component->get('configuration');
        if (strpos($config['id'], 'inline_block:') === 0) {
          $block = \Drupal::service('entity.repository')
            ->loadEntityByUuid('block_content', $config['uuid']);
          if (!$block instanceof BlockContent) {
            continue;
          }
          $contents[] = $block;
        }
      }
    }
    return $contents;
  }

}
